<?php


/*TESTED FUNCTION*/
function pan_converter_backup_db($date)
{
	global $db_name, $db_type, $forum_db, $db_prefix, $ext_info;
	
	// Increase time limit... in case its a big file or something.
	set_time_limit(99999999);
	define('N', "\r\n");
	
	//Tables of PunBB core 
	$punbb_arr = array('bans', 'categories',  'censoring', 'config', 'forum_perms', 'forums', 'groups', 'online', 'posts', 'ranks', 'reports', 'subscriptions', 'topics', 'users', 'extension_hooks', 'extensions');
	$dump = '-- SQL dump commenced at '.format_time(time()).N.'-- Generated by PunBB Backup Plugin'.N.'-- Dumping database `'.$db_name.'` - Database type: '.$db_type.N;
	$wrep = ';#%%';
	$rep = ';#%';
	switch ($db_type)
	{
		case 'mysql':
		case 'mysqli':
			$query = 'SHOW TABLES';
			break;
		case 'sqlite':
			$query = "SELECT * FROM sqlite_master WHERE type='table'";
			$wrep = ';--%%';
			$rep = ';--%';
		break;
		case 'pgsql':
			$query = "SELECT tablename FROM pg_tables WHERE (tableowner = current_user) AND ((tablename NOT Like('sql_%'))AND(tablename NOT Like('pg_%')))";
			$wrep = ';--%%';
			$rep = ';--%';
		break;
		default:
			message($lang_backup['Not supported DB']);
		break;
	}
	$tables = $forum_db->query($query);
	
	
//	print_r($tables);
	
	
	while($tmp_tab = $forum_db->fetch_row($tables))
	{
		$tab = $tmp_tab[0];
		if ($db_prefix != '' && strpos($db_prefix, $tab) != 0)
			continue;
		if ($db_type == 'mysql' || $db_type == 'mysqli'|| $db_type == 'pgsql')
		{
			$output = '';
			$result = $forum_db->query('SHOW CREATE TABLE `'.$tab.'`');
			while ($ins = $forum_db->fetch_row($result))
			{
				unset($ins[0]);
				$output .= implode(N,$ins);
			}
			$dump .= N.N.'-- '.N.'-- Table structure for '.$tab.N.'-- '.N.N;
			$dump .= 'DROP TABLE IF EXISTS `'.$tab.'`'.$wrep.N;
			$dump .= $output.$wrep;
		} 
		else if ($db_type == 'sqlite')
		{
			$table[0] = $table[1];
			$dump .= N.N.'-- '.N.'-- Table structure for '.$table[0].N.'-- '.N.N;
			$dump .= 'DROP TABLE IF EXISTS '.$table[0].$wrep.N;
			$dump .= str_replace("\t", '', $table[4]);
		}
		$result = $forum_db->query('SELECT * FROM '.$tab.' WHERE 1=1');
		$table_rows = $forum_db->num_rows($result);
		if ($table_rows > 0)
		{
			$dump .= N.N.'-- '.N.'-- Table data for '.$tab.N.'-- '.N;
			while($row = $forum_db->fetch_row($result))
			{
				$dump .= N.'INSERT INTO '.$tab.' VALUES (';
				$cols = count($row);
				$j = 0;
				foreach($row as $data)
				{
					$j++;
					while (strpos($data,$wrep)!== false)
						$data = str_replace($wrep,$rep, $data);
					if (!isset($data)) 
					{ 
						if ($j != $cols)
							$dump .= "NULL,";
						else
							$dump .= "NULL"; 
					}
					else if ($data != "")
						$dump .= '\''.$forum_db->escape($data).'\'' . ($j != $cols ? ', ' : '');
					else if ($data == "")
					{
						if ($j != $cols)
							$dump .= "'',";
						else
							$dump .= "''"; 
					}
				}
				$dump .= ')'.$wrep;
			}
		}
	}
	$dump .= N.'-- SQL dump concluded at '.format_time(time());

	$filepath = FORUM_ROOT.'extensions/pan_converter/dumps/';
	if (!file_exists($filepath))
		mkdir($filepath);

	$filename = $db_name.$date.'.sql';
	$file = fopen($filepath.$filename, "w+");
	if (!$file)
		message($lang_backup['Wrong filepath']);
	else
		fputs ( $file, $dump);
	
	fclose ($file);
//	add_to_log('backupDB', $filename);
	return $filename;

}



