<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';
require FORUM_ROOT.'extensions/pan_converter/functions.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

$section = isset($_GET['section']) ? $_GET['section'] : null;

if (isset($_POST['upload_module']))
{
	$file_name = basename($_FILES['module']['name']);
	$file_path = $forum_url['pan_converter_modules'].'/'.basename($_FILES['module']['name']);
	$file_url = forum_link($forum_url['pan_converter_dir_modules'].'/'.basename($_FILES['module']['name']));
	$mime_types = array('application/x-compressed', 'application/zip', 'application/octet-stream');

	if (in_array($_FILES['module']['type'], $mime_types)) 
	{
		if (move_uploaded_file($_FILES['module']['tmp_name'], $file_path)) 
		{
			if (file_exists($file_path))
			{
				$curl = curl_init($file_url);
				$fp = fopen($file_name, 'w');
				curl_setopt($curl, CURLOPT_FILE, $fp);
				curl_setopt($curl, CURLOPT_HEADER, 0);
				curl_exec($curl);
				curl_close($curl);
				fclose($fp);
				
				$zip = new ZipArchive;
				if ($zip->open($file_name) === true)
				{
					$zip->extractTo(FORUM_ROOT.$forum_url['pan_converter_dir_modules'].'/');
					$zip->close();
					
					if (file_exists(FORUM_ROOT.$forum_url['pan_converter_dir_modules'].'/'.$file_name))
					{
							@unlink(FORUM_ROOT.$forum_url['pan_converter_dir_modules'].'/'.$file_name);
							@unlink($file_name);
					} 
					$message = ' Module '.$file_name.' unpacked.';
				}
			}
		}
	}
	
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['pan_converter_settings']), $message);
}


if (isset($_POST['upload_dump']))
{
	$file_name = basename($_FILES['dump']['name']);
	$file_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$file_name;

	if (move_uploaded_file($_FILES['dump']['tmp_name'], $file_path)) 
	{
		if (file_exists($file_path))
			$message = ' Dump '.$file_name.' uploaded.';
	} else {
		$message = 'No such upload file.';
	}
	
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['pan_converter_settings']), $message);
}


if (isset($_POST['delete_dump']))
{
	$file_name = $_POST['sql_dump'];
	$file_path = FORUM_ROOT.$forum_url['pan_converter_dumps'].'/'.$file_name;
	$message = 'No such delete file.';
	
	if (file_exists($file_path)) {
		@unlink($file_path);
		$message = 'Dump file deleted.';
	}
	
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['pan_converter_settings']), $message);
}


if (isset($_POST['clear_db']))
{
	//DELETE ALL BANNED
	$query = array(
		'DELETE'	=> 'bans',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL CATEGORIES
	$query = array(
		'DELETE'	=> 'categories',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL CENSORING
	$query = array(
		'DELETE'	=> 'censoring',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL FORUMS
	$query = array(
		'DELETE'	=> 'forums',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL FORUM PERMISSIONS
	$query = array(
		'DELETE'	=> 'forum_perms',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL FORUM SUBSCRIPTIONS
	$query = array(
		'DELETE'	=> 'forum_subscriptions',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE GROUPS but 1 to 4
	$query = array(
		'DELETE'	=> 'groups',
		'WHERE'		=> 'g_id!=1 AND g_id!=2 AND g_id!=3 AND g_id!=4'
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL POSTS
	$query = array(
		'DELETE'	=> 'posts',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL REPORTS
	$query = array(
		'DELETE'	=> 'reports',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL SEARCH CACHE
	$query = array(
		'DELETE'	=> 'search_cache',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL SEARCH MATCHES
	$query = array(
		'DELETE'	=> 'search_matches',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL SEARCH WORDS
	$query = array(
		'DELETE'	=> 'search_words',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL TOPIC SUBSCRIPTIONS
	$query = array(
		'DELETE'	=> 'subscriptions',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL TOPICS
	$query = array(
		'DELETE'	=> 'topics',
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	//DELETE ALL USERS
	$query = array(
		'DELETE'	=> 'users',
		'WHERE'		=> 'id!=1 AND id!=2'
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$message = 'DataBase is cleared!';
	$forum_flash->add_info($message);
	redirect(forum_link($forum_url['pan_converter_settings']), $message);
}

if ($section != null)
{
	if (file_exists(FORUM_ROOT.'extensions/pan_converter/modules/'.$section.'/index.php'))
		require FORUM_ROOT.'extensions/pan_converter/modules/'.$section.'/index.php';
}
else
{
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array('Converter', forum_link($forum_url['pan_converter_settings'])),
		'Settings'
	);
	
	define('FORUM_PAGE_SECTION', 'pan-converter');
	define('FORUM_PAGE', 'admin-pan-converter');
	require FORUM_ROOT.'header.php';
	
	// START SUBST - <!-- forum_main -->
	ob_start();
?>
	<div class="main-subhead">
		<h2 class="hn"><span>Converter settings</span></h2>
	</div>
	
	<div class="main-content main-frm">
		
		<div class="content-head">
			 <h2 class="hn">Uploading Modules on server</h2>
		</div>
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo (forum_link($forum_url['pan_converter_settings'])) ?>" enctype="multipart/form-data">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_settings'])) ?>" />
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong>Upload module</strong></legend>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Upload module</span><small>Upload the module archive in ZIP format.</small></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" name="module" type="file" size="40" /></span>
					</div>
				</div>
				
			</fieldset>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="upload_module" value="Upload Module" /></span>
			</div>
		</form>


		<div class="content-head">
			 <h2 class="hn">Uploading Dumps on server</h2>
		</div>
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo (forum_link($forum_url['pan_converter_settings'])) ?>" enctype="multipart/form-data">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_settings'])) ?>" />
			</div>
			
			<div class="sf-set set">
				<div class="sf-box select">
					<label for="fld">
						<span>All Dump Files</span>
						<small>Select dump file for deleting.</small>
					</label><br />
					<span class="fld-input"><select name="sql_dump">
<?php

$available_files = pan_get_all_files(FORUM_ROOT.$forum_url['pan_converter_dumps'], array('sql', 'sqlite'));
foreach ($available_files as $sql_files) {
	echo "\t\t\t\t\t\t\t\t".'<option value="'.$sql_files.'">'.$sql_files.'</option>'."\n";
}

?>
						</select>
					</span>
				</div>
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong>Upload Dump</strong></legend>
				
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box text required">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span>Upload Dump</span><small>Upload the SQL Dump file in .sql format.</small></label><br />
						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" name="dump" type="file" size="40" /></span>
					</div>
				</div>
				
			</fieldset>
			
			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="upload_dump" value="Upload Dump" /></span>
				<span class="submit primary"><input type="submit" name="delete_dump" value="Delete Dump" /></span>
			</div>
		</form>



		<div class="content-head">
			 <h2 class="hn">Crearing All DataBase</h2>
		</div>
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo (forum_link($forum_url['pan_converter_settings'])) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_converter_settings'])) ?>" />
			</div>
			
			<div class="frm-form">
				<div class="ct-box">
					<p><strong>Notice!</strong></p>
					<p>This function will not delete the entire database. It clears only the main tables except: USERS, GROUPS and CONFIG.</p>
				</div>
			</div>
			
			<div class="frm-buttons">
				<span class="submit primary caution"><input type="submit" name="clear_db" value="Clear DB" /></span>
			</div>
		</form>


	</div>

<?php
	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->
}

require FORUM_ROOT.'footer.php';
